#include <stdio.h>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "6502.h"

void *__gxx_personality_v0() {return 0;}
WORD addrmask;
BYTE *gameImage;
extern void init6502();
extern void *cpu_thread_func(void* x);
extern void *cpu_monitor_thread_func(void* x);

BYTE dataimg[65536];

void load_image() {
  	int i=0, c;
	FILE *data;
	struct stat buf;
	stat("data.img",&buf);
	int fsize = buf.st_size;	
	printf("loading %d bytes image\n", fsize);
	data = fopen("data.img","rb");
	for(i = 0; i < 65536; i++) gameImage[i] = 0;
	i = 0;
	while(fsize > 0) {
		c = fgetc(data);
		if(i > 65535) { printf("image file too big, exit\n"); exit(-1); }
		gameImage[i] = (BYTE)c&0xff;
		i++;
		fsize--;
	}
	fclose(data);
}

int main() {
	pthread_t cpu_thread, monitor_thread;
	init6502();
	gameImage = dataimg;
	load_image();
	
	pthread_create(&cpu_thread, NULL, &cpu_thread_func, NULL);
	pthread_create(&monitor_thread, NULL, &cpu_monitor_thread_func, NULL);
	for(;;);
	return(0);
}

